DROP TABLE RAO_SOCIAL CASCADE CONSTRAINTS;

CREATE TABLE RAO_SOCIAL (
  CODI NUMBER(1) CONSTRAINT EMPRESA_PK PRIMARY KEY
                 CONSTRAINT EMPRESA_CODI_CK CHECK (CODI=1),
  NOM VARCHAR2(60) CONSTRAINT EMPRESA_NM_NOM NOT NULL,
  DATA_CREACIO DATE CONSTRAINT EMPRESA_NN_DATA_CREACIO NOT NULL
);

DROP TABLE DEPT CASCADE CONSTRAINTS;

CREATE TABLE DEPT (
 DEPT_NO  NUMBER(2) CONSTRAINT DEPT_PK PRIMARY KEY
                    CONSTRAINT DEPT_CK_COD_POSITIU CHECK (DEPT_NO > 0),
 DNOM     VARCHAR(14) CONSTRAINT DEPT_NN_DNOM NOT NULL 
                      CONSTRAINT DEPT_UN_DNOM UNIQUE,
 LOC      VARCHAR(14) ) ;

DROP TABLE EMP CASCADE CONSTRAINTS;

CREATE TABLE EMP (
 EMP_NO    NUMBER(4) CONSTRAINT EMP_PK PRIMARY KEY
                     CONSTRAINT EMP_CK_COD_POSITIU CHECK (EMP_NO > 0),
 COGNOM    VARCHAR(10) CONSTRAINT EMP_NN_COGNOM NOT NULL,
 OFICI     VARCHAR(10),
 CAP       NUMBER(4) CONSTRAINT EMP_FK_EMP REFERENCES EMP ON DELETE SET NULL,
 DATA_ALTA DATE,
 SALARI    NUMBER(10) CONSTRAINT EMP_CK_SALARI CHECK (SALARI >=0),
 COMISSIO  NUMBER(10) CONSTRAINT EMP_CK_COMISSIO CHECK (COMISSIO >= 0),
 DEPT_NO   NUMBER(2) CONSTRAINT EMP_FK_DEPT REFERENCES DEPT) ;

CREATE INDEX EMP_COGNOM ON EMP (COGNOM);
CREATE INDEX "EMP_DEPT_NO+EMP" ON EMP (DEPT_NO,EMP_NO);

